Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsExhaustiveLSManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsExhaustiveLSManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsExhaustiveLSManipulator.cs	(revision 5177)
@@ -39,5 +39,5 @@
     }
 
-    protected override void Manipulate(IRandom random, PrinsEncoding individual) {
+    protected override void Manipulate(IExecutionContext context, IRandom random, PrinsEncoding individual) {
       List<Tour> tours = individual.GetTours(DistanceMatrixParameter);
       bool improvement = false;
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsManipulator.cs	(revision 5177)
@@ -64,7 +64,7 @@
     }
 
-    protected abstract void Manipulate(IRandom random, PrinsEncoding individual);
+    protected abstract void Manipulate(IExecutionContext context, IRandom random, PrinsEncoding individual);
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IVRPEncoding solution = VRPToursParameter.ActualValue;
       if (!(solution is PrinsEncoding)) {
@@ -86,7 +86,7 @@
       }
 
-      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as PrinsEncoding);
+      Manipulate(context, RandomParameter.ActualValue, VRPToursParameter.ActualValue as PrinsEncoding);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsPermutationManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsPermutationManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsPermutationManipulator.cs	(revision 5177)
@@ -45,9 +45,9 @@
     }
 
-    protected override void Manipulate(IRandom random, PrinsEncoding individual) {
+    protected override void Manipulate(IExecutionContext context, IRandom random, PrinsEncoding individual) {
       InnerManipulatorParameter.ActualValue.PermutationParameter.ActualName = VRPToursParameter.ActualName;
 
-      IAtomicOperation op = this.ExecutionContext.CreateOperation(
-        InnerManipulatorParameter.ActualValue, this.ExecutionContext.Scope);
+      IAtomicOperation op = context.CreateOperation(
+        InnerManipulatorParameter.ActualValue, context.Scope);
       op.Operator.Execute((IExecutionContext)op);
     }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsStochasticLSManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsStochasticLSManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Prins/Manipulators/PrinsStochasticLSManipulator.cs	(revision 5177)
@@ -46,5 +46,5 @@
     }
 
-    protected override void Manipulate(IRandom random, PrinsEncoding individual) {
+    protected override void Manipulate(IExecutionContext context, IRandom random, PrinsEncoding individual) {
       List<Tour> tours = individual.GetTours(DistanceMatrixParameter);
       bool improvement = false;
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuCrossover.cs	(revision 5177)
@@ -45,7 +45,7 @@
     }
 
-    protected abstract ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2);
+    protected abstract ZhuEncoding Crossover(IExecutionContext context, IRandom random, ZhuEncoding parent1, ZhuEncoding parent2);
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<IVRPEncoding> parents = new ItemArray<IVRPEncoding>(ParentsParameter.ActualValue.Length);
       for (int i = 0; i < ParentsParameter.ActualValue.Length; i++) {
@@ -70,7 +70,7 @@
 
       ChildParameter.ActualValue =
-        Crossover(RandomParameter.ActualValue, parents[0] as ZhuEncoding, parents[1] as ZhuEncoding);
+        Crossover(context, RandomParameter.ActualValue, parents[0] as ZhuEncoding, parents[1] as ZhuEncoding);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover1.cs	(revision 5177)
@@ -49,5 +49,5 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncoding Crossover(IExecutionContext context, IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
       parent1 = parent1.Clone() as ZhuEncoding;
       parent2 = parent2.Clone() as ZhuEncoding;
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuHeuristicCrossover2.cs	(revision 5177)
@@ -41,5 +41,5 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncoding Crossover(IExecutionContext context, IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
       List<int> p1 = new List<int>(parent1);
       List<int> p2 = new List<int>(parent2);
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuMergeCrossover1.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuMergeCrossover1.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuMergeCrossover1.cs	(revision 5177)
@@ -49,5 +49,5 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncoding Crossover(IExecutionContext context, IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
       parent1 = parent1.Clone() as ZhuEncoding;
       parent2 = parent2.Clone() as ZhuEncoding;
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuMergeCrossover2.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuMergeCrossover2.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuMergeCrossover2.cs	(revision 5177)
@@ -41,5 +41,5 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncoding Crossover(IExecutionContext context, IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
       List<int> p1 = new List<int>(parent1);
       List<int> p2 = new List<int>(parent2);
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuPermutationCrossover.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuPermutationCrossover.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Crossovers/ZhuPermutationCrossover.cs	(revision 5177)
@@ -47,17 +47,17 @@
     }
 
-    protected override ZhuEncoding Crossover(IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
+    protected override ZhuEncoding Crossover(IExecutionContext context, IRandom random, ZhuEncoding parent1, ZhuEncoding parent2) {
       //note - the inner crossover is called here and the result is converted to a prins representation
       //some refactoring should be done here in the future - the crossover operation should be called directly
 
       InnerCrossoverParameter.ActualValue.ParentsParameter.ActualName = ParentsParameter.ActualName;
-      IAtomicOperation op = this.ExecutionContext.CreateOperation(
-        InnerCrossoverParameter.ActualValue, this.ExecutionContext.Scope);
+      IAtomicOperation op = context.CreateOperation(
+        InnerCrossoverParameter.ActualValue, context.Scope);
       op.Operator.Execute((IExecutionContext)op);
 
       string childName = InnerCrossoverParameter.ActualValue.ChildParameter.ActualName;
-      if (ExecutionContext.Scope.Variables.ContainsKey(childName)) {
-        Permutation permutation = ExecutionContext.Scope.Variables[childName].Value as Permutation;
-        ExecutionContext.Scope.Variables.Remove(childName);
+      if (context.Scope.Variables.ContainsKey(childName)) {
+        Permutation permutation = context.Scope.Variables[childName].Value as Permutation;
+        context.Scope.Variables.Remove(childName);
 
         return new ZhuEncoding(permutation, Cities,
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Manipulators/ZhuManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Manipulators/ZhuManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Manipulators/ZhuManipulator.cs	(revision 5177)
@@ -45,7 +45,7 @@
     }
 
-    protected abstract void Manipulate(IRandom random, ZhuEncoding individual);
+    protected abstract void Manipulate(IExecutionContext context, IRandom random, ZhuEncoding individual);
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IVRPEncoding solution = VRPToursParameter.ActualValue;
       if (!(solution is ZhuEncoding)) {
@@ -62,7 +62,7 @@
       }
 
-      Manipulate(RandomParameter.ActualValue, VRPToursParameter.ActualValue as ZhuEncoding);
+      Manipulate(context, RandomParameter.ActualValue, VRPToursParameter.ActualValue as ZhuEncoding);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Manipulators/ZhuPermutationManipulator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Manipulators/ZhuPermutationManipulator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Encodings/Zhu/Manipulators/ZhuPermutationManipulator.cs	(revision 5177)
@@ -47,9 +47,9 @@
     }
 
-    protected override void Manipulate(IRandom random, ZhuEncoding individual) {
+    protected override void Manipulate(IExecutionContext context, IRandom random, ZhuEncoding individual) {
       InnerManipulatorParameter.ActualValue.PermutationParameter.ActualName = VRPToursParameter.ActualName;
 
-      IAtomicOperation op = this.ExecutionContext.CreateOperation(
-        InnerManipulatorParameter.ActualValue, this.ExecutionContext.Scope);
+      IAtomicOperation op = context.CreateOperation(
+        InnerManipulatorParameter.ActualValue, context.Scope);
       op.Operator.Execute((IExecutionContext)op);
     }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Evaluators/VRPEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Evaluators/VRPEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Evaluators/VRPEvaluator.cs	(revision 5177)
@@ -214,5 +214,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       IVRPEncoding solution = VRPToursParameter.ActualValue;
 
@@ -229,5 +229,5 @@
       TardinessParameter.ActualValue = new DoubleValue(sumEval.Tardiness);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/MoveEvaluators/VRPMoveEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/MoveEvaluators/VRPMoveEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/MoveEvaluators/VRPMoveEvaluator.cs	(revision 5177)
@@ -99,5 +99,5 @@
     protected abstract TourEvaluation GetMoveQuality();
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       TourEvaluation tourEval = GetMoveQuality();
 
@@ -109,5 +109,5 @@
       MoveTravelTimeParameter.ActualValue = new DoubleValue(tourEval.TravelTime);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Random/3.3/NormalRandomizer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Random/3.3/NormalRandomizer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Random/3.3/NormalRandomizer.cs	(revision 5177)
@@ -81,5 +81,5 @@
     /// Generates a new normally distributed random variable and assigns it to the specified variable.
     /// </summary>
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IRandom random = RandomParameter.ActualValue;
       double mu = MuParameter.ActualValue.Value;
Index: /branches/ParallelEngine/HeuristicLab.Random/3.3/RandomCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Random/3.3/RandomCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Random/3.3/RandomCreator.cs	(revision 5177)
@@ -88,5 +88,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       if (SetSeedRandomlyParameter.ActualValue == null) SetSeedRandomlyParameter.ActualValue = new BoolValue(true);
       bool setSeedRandomly = SetSeedRandomlyParameter.ActualValue.Value;
@@ -99,5 +99,5 @@
       RandomParameter.ActualValue = random;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Random/3.3/UniformRandomizer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Random/3.3/UniformRandomizer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Random/3.3/UniformRandomizer.cs	(revision 5177)
@@ -83,5 +83,5 @@
     /// Generates a new uniformly distributed random variable.
     /// </summary>
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IRandom random = RandomParameter.ActualValue;
       double min = MinParameter.ActualValue.Value;
Index: /branches/ParallelEngine/HeuristicLab.Selection/3.3/GenderSpecificSelector.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Selection/3.3/GenderSpecificSelector.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Selection/3.3/GenderSpecificSelector.cs	(revision 5177)
@@ -140,10 +140,10 @@
     /// <exception cref="InvalidOperationException">Thrown when <see cref="NumberOfSelectedSubScopesParameter"/> returns an odd number.</exception>
     /// <returns>Returns Apply of <see cref="AlgorithmOperator"/>.</returns>
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
       if (count % 2 > 0) throw new InvalidOperationException(Name + ": There must be an equal number of sub-scopes to be selected.");
       FemaleSelector.NumberOfSelectedSubScopesParameter.Value = new IntValue(count / 2);
       MaleSelector.NumberOfSelectedSubScopesParameter.Value = new IntValue(count / 2);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Selection/3.3/OffspringSelector.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Selection/3.3/OffspringSelector.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Selection/3.3/OffspringSelector.cs	(revision 5177)
@@ -80,8 +80,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       double maxSelPress = MaximumSelectionPressureParameter.ActualValue.Value;
       double successRatio = SuccessRatioParameter.ActualValue.Value;
-      IScope scope = ExecutionContext.Scope;
+      IScope scope = context.Scope;
       IScope parents = scope.SubScopes[0];
       IScope offspring = scope.SubScopes[1];
@@ -162,5 +162,5 @@
         IOperator moreOffspring = OffspringCreatorParameter.ActualValue as IOperator;
         if (moreOffspring == null) throw new InvalidOperationException(Name + ": More offspring are required, but no operator specified for creating them.");
-        return ExecutionContext.CreateOperation(moreOffspring);
+        return context.CreateOperation(moreOffspring);
       } else {
         // enough children generated
@@ -170,5 +170,5 @@
         scope.Variables.Remove(OffspringPopulationParameter.TranslatedName);
         scope.Variables.Remove(OffspringPopulationWinnersParameter.TranslatedName);
-        return base.Apply();
+        return base.Apply(context);
       }
     }
Index: /branches/ParallelEngine/HeuristicLab.Selection/3.3/Reducer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Selection/3.3/Reducer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Selection/3.3/Reducer.cs	(revision 5177)
@@ -52,5 +52,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       List<IScope> scopes = new List<IScope>(CurrentScope.SubScopes);
       List<IScope> reduced = Reduce(scopes);
@@ -59,5 +59,5 @@
       CurrentScope.SubScopes.AddRange(reduced);
 
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Selection/3.3/Replacer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Selection/3.3/Replacer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Selection/3.3/Replacer.cs	(revision 5177)
@@ -75,8 +75,8 @@
     }
 
-    public override IOperation Apply() {
-      if (ExecutionContext.Scope.SubScopes.Count != 2) throw new InvalidOperationException(Name + ": There must be two sub-scopes which should be replaced/merged.");
-      int remaining = ExecutionContext.Scope.SubScopes[0].SubScopes.Count;
-      int selected = ExecutionContext.Scope.SubScopes[1].SubScopes.Count;
+    public override IOperation Apply(IExecutionContext context) {
+      if (context.Scope.SubScopes.Count != 2) throw new InvalidOperationException(Name + ": There must be two sub-scopes which should be replaced/merged.");
+      int remaining = context.Scope.SubScopes[0].SubScopes.Count;
+      int selected = context.Scope.SubScopes[1].SubScopes.Count;
 
       ISelector replacedSelector = ReplacedSelectorParameter.ActualValue;
@@ -92,5 +92,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Selection/3.3/Selector.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Selection/3.3/Selector.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Selection/3.3/Selector.cs	(revision 5177)
@@ -54,5 +54,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       List<IScope> scopes = new List<IScope>(CurrentScope.SubScopes);
       IScope[] selected = Select(scopes);
@@ -66,5 +66,5 @@
       CurrentScope.SubScopes.Add(selectedScope);
 
-      return base.Apply();
+      return base.Apply(context);
     }
 
